"""create_validator_nodes_and_signatures

Revision ID: d10f1f88af0f
Revises: 2b93b957d8a4
Create Date: 2024-03-19 05:15:51.187537

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = 'd10f1f88af0f'
down_revision = '2b93b957d8a4'
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        'validator_nodes', sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('forwarder_contract_id', sa.Integer(), nullable=False),
        sa.Column('address', sa.String(length=42), nullable=False),
        sa.Column('created', sa.DateTime(), nullable=False),
        sa.ForeignKeyConstraint(
            ['forwarder_contract_id'],
            ['forwarder_contracts.id'],
        ), sa.PrimaryKeyConstraint('id'),
        sa.UniqueConstraint('forwarder_contract_id', 'address'))
    op.create_table(
        'validator_node_signatures',
        sa.Column('transfer_id', sa.Integer(), nullable=False),
        sa.Column('validator_node_id', sa.Integer(), nullable=False),
        sa.Column('signature', sa.String(length=132), nullable=False),
        sa.Column('created', sa.DateTime(), nullable=False),
        sa.ForeignKeyConstraint(
            ['transfer_id'],
            ['transfers.id'],
        ),
        sa.ForeignKeyConstraint(
            ['validator_node_id'],
            ['validator_nodes.id'],
        ), sa.PrimaryKeyConstraint('transfer_id', 'validator_node_id'),
        sa.UniqueConstraint('signature'))
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('validator_node_signatures')
    op.drop_table('validator_nodes')
    # ### end Alembic commands ###
